package cz.muni.fi.pb138.jaro2017.task1;

import javax.xml.xpath.XPathFactory;
import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.XMLConstants;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * ***********************************************************************
 * Take this skeleton code and implement the missing bodies of
 * <code>averageSalaryAtPosition</code> and <code>addNote</code> methods.
 * Everything else should be left untouched.<br/>
 *
 * After completion, the <code>main</code> method should work correctly.<br/>
 * It reads (parses) the given file (company.xml if you run it directly from the
 * Netbeans project) and processes it using your methods.
 *
 */
public class Main {

    /**
     * W3C object model representation of a XML document. Note: We use the
     * interface(!) not its implementation
     */
    private Document doc;

    /**
     * Task 1, part A: Complete this method. You are likely to consult the Java
     * Core API documentation for org.w3c.dom package when working on this task.
     * You can also use the XPath sub-API (javax.xml.xpath) to evaluate XPath
     * expressions from within Java methods.
     *
     * Hint for those not experienced in Java: you can use double
     * Double.parseDouble (String s) to convert the text node inside the salary
     * element to a double value.
     *
     * You can suppose that the input document is always valid, i.e. its
     * structure fulfills the criteria specified in the comments inside the
     * document company.xml.
     *
     * Returns the average salary at given position for each division in the
     * company.
     * 
     * You can create and use additional (private) methods you would need.
     *
     * @param position the position its average salary has to be calculated.
     * @return Element "avgsalaries" containing for each division 
     * elements "avgsalary" with the average salary at this division 
     * at the given position. The average salary is stored in its text content 
     * and the division id as its attribute "did".
     * 
     * I.e. the demo output of method Main.main should look like:
     * 
Average salaries at position tester:
<?xml version="1.0" encoding="UTF-8"?>
<avgsalaries><avgsalary did="production_zlin" position="tester">39000.0</avgsalary>
<avgsalary did="development_brno" position="tester">26422.75</avgsalary></avgsalaries>
     * 
     * 
     */
    public Element averageSalariesAtPosition(String position) throws XPathExpressionException {
        Element salaries = doc.createElement("avgsalaries");
        // complete the method here
        return salaries;
    }

    /**
     * Task 1, part B: Complete this method. The method adds a new note to an
     * existing person identified by its person ID (pid) and returns 
     * this person element. If such a person does
     * not exist, the method does nothing and returns null.
     *
     * You can create and use additional (private) methods you would need.
     *
     * @param pid of the person to add the note to this person. pid must not be
     * null nor empty (the method does not check it)
     * @param note the note to be added to the person with the given pid
     * @return the Element person with the given pid and new note added 
     * or null if such person Element does not exist.
     * 
     * The demo (method Main.main) should produce the following output:
     * 
     * Person with pid=1 is now:
<?xml version="1.0" encoding="UTF-8"?>
<person pid="1"> 	
<!-- name is required, non-empty string -->	 
<name>Pavel</name>	 
<!-- surname is required, non-empty string -->
<surname>Novák</surname> 
<!-- note optional element, repeatable, contains any string -->  
<note>Poznámka</note>   
<note>New note to person 1</note></person>
     */
    
    public Element addNote(String pid, String note) {
        // complete the method
        
        return null;
    }

    /**
     * **********************************************************************
     */
    /**
     * Vytvori novou instanci teto tridy a nacte obsah xml dokumentu se zadanym
     * URL.
     */
    public static Main newInstance(URI uri) throws SAXException,
            ParserConfigurationException, IOException {
        return new Main(uri);
    }

    /**
     * Create a new instance of this class and read the content of the given XML
     * file.
     */
    public static Main newInstance(File file)
            throws SAXException, ParserConfigurationException, IOException {
        return newInstance(file.toURI());
    }

    /**
     * Constructor creating a new instance of Uloha1 class reading from the file
     * at the given URI
     */
    private Main(URI uri) throws SAXException, ParserConfigurationException,
            IOException {
        // Vytvorime instanci tovarni tridy
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci DocumentBuilderu
        DocumentBuilder builder = factory.newDocumentBuilder();
        // DocumentBuilder pouzijeme pro zpracovani XML dokumentu
        // a ziskame model dokumentu ve formatu W3C DOM
        doc = builder.parse(uri.toString());
    }

    public void serializetoXML(URI output)
            throws IOException, TransformerConfigurationException, TransformerException {
        // Vytvorime instanci tovarni tridy
        TransformerFactory factory = TransformerFactory.newInstance();
        // Pomoci tovarni tridy ziskame instanci tzv. kopirovaciho transformeru
        Transformer transformer = factory.newTransformer();
        // Vstupem transformace bude dokument v pameti
        DOMSource source = new DOMSource(doc);
        // Vystupem transformace bude vystupni soubor
        StreamResult result = new StreamResult(output.toString());
        // Provedeme transformaci
        transformer.transform(source, result);
    }

    public void serializetoXML(File output) throws IOException,
            TransformerException {
        serializetoXML(output.toURI());
    }

    /**
     * Expected output when executed is:
Running demo...
Average salaries at position tester:
<?xml version="1.0" encoding="UTF-8"?><avgsalaries><avgsalary did="production_zlin" position="tester">39000.0</avgsalary><avgsalary did="development_brno" position="tester">26422.75</avgsalary></avgsalaries>
Person with pid=1 is now:
<?xml version="1.0" encoding="UTF-8"?><person pid="1"> 	
                <!-- name is required, non-empty string -->	 
                <name>Pavel</name>	 
                <!-- surname is required, non-empty string -->
                <surname>Novák</surname> 
                <!-- note optional element, repeatable, contains any string -->  
                <note>Poznámka</note>   
            <note>New note to person 1</note></person>
Demo finished, see the above output to check whether it is correct.
     */
    public static void main(String[] args) throws IOException, SAXException, ParserConfigurationException, TransformerException {

        System.out.println("Running demo...");
        if (args.length < 1) {
            System.err.println("Input file name is missing.");
            return;
        } else if (args.length < 2) {
            System.err.println("Output file name is missing.");
            return;
        }

        File input = new File(args[0]);
        File output = new File(args[1]);

        Main task1 = newInstance(input);

        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer trans = tf.newTransformer();
        try {
            System.out.println("Average salaries at position tester:");
            trans.transform(new DOMSource(task1.averageSalariesAtPosition("tester")), new StreamResult(System.out));

            System.out.println("\nPerson with pid=1 is now:");
            trans.transform(new DOMSource(task1.addNote("1", "New note to person 1")), new StreamResult(System.out));
    
            task1.serializetoXML(output);
        } catch (XPathExpressionException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, "Error in averageSalariesAtPosition or addNote", ex);
        }
        System.out.println("\nDemo finished, see the above output to check whether it is correct.");
    }

    /**
     * Help method for testing purposes.
     */
    Document getDocument() {
        return doc;
    }

}
